var dust={};
function getGlobal(){return(function(){return this.dust;
}).call(null);
}(function(dust){dust.cache={};
dust.register=function(name,tmpl){if(!name){return;
}dust.cache[name]=tmpl;
};
dust.render=function(name,context,callback){var chunk=new Stub(callback).head;
dust.load(name,chunk,Context.wrap(context)).end();
};
dust.stream=function(name,context){var stream=new Stream();
dust.nextTick(function(){dust.load(name,stream.head,Context.wrap(context)).end();
});
return stream;
};
dust.renderSource=function(source,context,callback){return dust.compileFn(source)(context,callback);
};
dust.compileFn=function(source,name){var tmpl=dust.loadSource(dust.compile(source,name));
return function(context,callback){var master=callback?new Stub(callback):new Stream();
dust.nextTick(function(){tmpl(master.head,Context.wrap(context)).end();
});
return master;
};
};
dust.load=function(name,chunk,context){var tmpl=dust.cache[name];
if(tmpl){return tmpl(chunk,context);
}else{if(dust.onLoad){return chunk.map(function(chunk){dust.onLoad(name,function(err,src){if(err){return chunk.setError(err);
}if(!dust.cache[name]){dust.loadSource(dust.compile(src,name));
}dust.cache[name](chunk,context).end();
});
});
}return chunk.setError(new Error("Template Not Found: "+name));
}};
dust.loadSource=function(source,path){return eval(source);
};
if(Array.isArray){dust.isArray=Array.isArray;
}else{dust.isArray=function(arr){return Object.prototype.toString.call(arr)=="[object Array]";
};
}dust.nextTick=(function(){if(typeof process!=="undefined"){return process.nextTick;
}else{return function(callback){setTimeout(callback,0);
};
}})();
dust.isEmpty=function(value){if(dust.isArray(value)&&!value.length){return true;
}if(value===0){return false;
}return(!value);
};
dust.filter=function(string,auto,filters){if(filters){for(var i=0,len=filters.length;
i<len;
i++){var name=filters[i];
if(name==="s"){auto=null;
}else{if(typeof dust.filters[name]==="function"){string=dust.filters[name](string);
}}}}if(auto){string=dust.filters[auto](string);
}return string;
};
dust.filters={h:function(value){return dust.escapeHtml(value);
},j:function(value){return dust.escapeJs(value);
},u:encodeURI,uc:encodeURIComponent,js:function(value){if(!JSON){return value;
}return JSON.stringify(value);
},jp:function(value){if(!JSON){return value;
}return JSON.parse(value);
}};
function Context(stack,global,blocks){this.stack=stack;
this.global=global;
this.blocks=blocks;
}dust.makeBase=function(global){return new Context(new Stack(),global);
};
Context.wrap=function(context){if(context instanceof Context){return context;
}return new Context(new Stack(context));
};
Context.prototype.get=function(key){var ctx=this.stack,value;
while(ctx){if(ctx.isObject){value=ctx.head[key];
if(!(value===undefined)){return value;
}}ctx=ctx.tail;
}return this.global?this.global[key]:undefined;
};
Context.prototype.getPath=function(cur,down){var ctx=this.stack,len=down.length;
if(cur&&len===0){return ctx.head;
}ctx=ctx.head;
var i=0;
while(ctx&&i<len){ctx=ctx[down[i]];
i++;
}return ctx;
};
Context.prototype.push=function(head,idx,len){return new Context(new Stack(head,this.stack,idx,len),this.global,this.blocks);
};
Context.prototype.rebase=function(head){return new Context(new Stack(head),this.global,this.blocks);
};
Context.prototype.current=function(){return this.stack.head;
};
Context.prototype.getBlock=function(key,chk,ctx){if(typeof key==="function"){key=key(chk,ctx).data;
chk.data="";
}var blocks=this.blocks;
if(!blocks){return;
}var len=blocks.length,fn;
while(len--){fn=blocks[len][key];
if(fn){return fn;
}}};
Context.prototype.shiftBlocks=function(locals){var blocks=this.blocks,newBlocks;
if(locals){if(!blocks){newBlocks=[locals];
}else{newBlocks=blocks.concat([locals]);
}return new Context(this.stack,this.global,newBlocks);
}return this;
};
function Stack(head,tail,idx,len){this.tail=tail;
this.isObject=!dust.isArray(head)&&head&&typeof head==="object";
this.head=head;
this.index=idx;
this.of=len;
}function Stub(callback){this.head=new Chunk(this);
this.callback=callback;
this.out="";
}Stub.prototype.flush=function(){var chunk=this.head;
while(chunk){if(chunk.flushable){this.out+=chunk.data;
}else{if(chunk.error){this.callback(chunk.error);
this.flush=function(){};
return;
}else{return;
}}chunk=chunk.next;
this.head=chunk;
}this.callback(null,this.out);
};
function Stream(){this.head=new Chunk(this);
}Stream.prototype.flush=function(){var chunk=this.head;
while(chunk){if(chunk.flushable){this.emit("data",chunk.data);
}else{if(chunk.error){this.emit("error",chunk.error);
this.flush=function(){};
return;
}else{return;
}}chunk=chunk.next;
this.head=chunk;
}this.emit("end");
};
Stream.prototype.emit=function(type,data){if(!this.events){return false;
}var handler=this.events[type];
if(!handler){return false;
}if(typeof handler=="function"){handler(data);
}else{var listeners=handler.slice(0);
for(var i=0,l=listeners.length;
i<l;
i++){listeners[i](data);
}}};
Stream.prototype.on=function(type,callback){if(!this.events){this.events={};
}if(!this.events[type]){this.events[type]=callback;
}else{if(typeof this.events[type]==="function"){this.events[type]=[this.events[type],callback];
}else{this.events[type].push(callback);
}}return this;
};
Stream.prototype.pipe=function(stream){this.on("data",function(data){stream.write(data,"utf8");
}).on("end",function(){stream.end();
}).on("error",function(err){stream.error(err);
});
return this;
};
function Chunk(root,next,taps){this.root=root;
this.next=next;
this.data="";
this.flushable=false;
this.taps=taps;
}Chunk.prototype.write=function(data){var taps=this.taps;
if(taps){data=taps.go(data);
}this.data+=data;
return this;
};
Chunk.prototype.end=function(data){if(data){this.write(data);
}this.flushable=true;
this.root.flush();
return this;
};
Chunk.prototype.map=function(callback){var cursor=new Chunk(this.root,this.next,this.taps),branch=new Chunk(this.root,cursor,this.taps);
this.next=branch;
this.flushable=true;
callback(branch);
return cursor;
};
Chunk.prototype.tap=function(tap){var taps=this.taps;
if(taps){this.taps=taps.push(tap);
}else{this.taps=new Tap(tap);
}return this;
};
Chunk.prototype.untap=function(){this.taps=this.taps.tail;
return this;
};
Chunk.prototype.render=function(body,context){return body(this,context);
};
Chunk.prototype.reference=function(elem,context,auto,filters){if(typeof elem==="function"){elem.isFunction=true;
elem=elem.apply(context.current(),[this,context,null,{auto:auto,filters:filters}]);
if(elem instanceof Chunk){return elem;
}}if(!dust.isEmpty(elem)){return this.write(dust.filter(elem,auto,filters));
}else{return this;
}};
Chunk.prototype.section=function(elem,context,bodies,params){if(typeof elem==="function"){elem=elem.apply(context.current(),[this,context,bodies,params]);
if(elem instanceof Chunk){return elem;
}}var body=bodies.block,skip=bodies["else"];
if(params){context=context.push(params);
}if(dust.isArray(elem)){if(body){var len=elem.length,chunk=this;
if(len>0){if(context.stack.head){context.stack.head["$len"]=len;
}for(var i=0;
i<len;
i++){if(context.stack.head){context.stack.head["$idx"]=i;
}chunk=body(chunk,context.push(elem[i],i,len));
}if(context.stack.head){context.stack.head["$idx"]=undefined;
context.stack.head["$len"]=undefined;
}return chunk;
}else{if(skip){return skip(this,context);
}}}}else{if(elem===true){if(body){return body(this,context);
}}else{if(elem||elem===0){if(body){if(context.stack.head&&typeof elem==="object"){context.stack.head["$idx"]=0;
context.stack.head["$len"]=1;
}chunk=body(this,context.push(elem));
if(context.stack.head&&typeof elem==="object"){context.stack.head["$idx"]=undefined;
context.stack.head["$len"]=undefined;
}return chunk;
}}else{if(skip){return skip(this,context);
}}}}return this;
};
Chunk.prototype.exists=function(elem,context,bodies){var body=bodies.block,skip=bodies["else"];
if(!dust.isEmpty(elem)){if(body){return body(this,context);
}}else{if(skip){return skip(this,context);
}}return this;
};
Chunk.prototype.notexists=function(elem,context,bodies){var body=bodies.block,skip=bodies["else"];
if(dust.isEmpty(elem)){if(body){return body(this,context);
}}else{if(skip){return skip(this,context);
}}return this;
};
Chunk.prototype.block=function(elem,context,bodies){var body=bodies.block;
if(elem){body=elem;
}if(body){return body(this,context);
}return this;
};
Chunk.prototype.partial=function(elem,context,params){var partialContext;
if(params){partialContext=dust.makeBase(context.global);
partialContext.blocks=context.blocks;
if(context.stack&&context.stack.tail){partialContext.stack=context.stack.tail;
}partialContext=partialContext.push(params);
partialContext=partialContext.push(context.stack.head);
}else{partialContext=context;
}if(typeof elem==="function"){return this.capture(elem,partialContext,function(name,chunk){dust.load(name,chunk,partialContext).end();
});
}return dust.load(elem,this,partialContext);
};
Chunk.prototype.helper=function(name,context,bodies,params){if(dust.helpers[name]){return dust.helpers[name](this,context,bodies,params);
}};
Chunk.prototype.capture=function(body,context,callback){return this.map(function(chunk){var stub=new Stub(function(err,out){if(err){chunk.setError(err);
}else{callback(out,chunk);
}});
body(stub.head,context).end();
});
};
Chunk.prototype.setError=function(err){this.error=err;
this.root.flush();
return this;
};
function Tap(head,tail){this.head=head;
this.tail=tail;
}Tap.prototype.push=function(tap){return new Tap(tap,this);
};
Tap.prototype.go=function(value){var tap=this;
while(tap){value=tap.head(value);
tap=tap.tail;
}return value;
};
var HCHARS=new RegExp(/[&<>\"\']/),AMP=/&/g,LT=/</g,GT=/>/g,QUOT=/\"/g,SQUOT=/\'/g;
dust.escapeHtml=function(s){if(typeof s==="string"){if(!HCHARS.test(s)){return s;
}return s.replace(AMP,"&amp;").replace(LT,"&lt;").replace(GT,"&gt;").replace(QUOT,"&quot;").replace(SQUOT,"&#39;");
}return s;
};
var BS=/\\/g,CR=/\r/g,LS=/\u2028/g,PS=/\u2029/g,NL=/\n/g,LF=/\f/g,SQ=/'/g,DQ=/"/g,TB=/\t/g;
dust.escapeJs=function(s){if(typeof s==="string"){return s.replace(BS,"\\\\").replace(DQ,'\\"').replace(SQ,"\\'").replace(CR,"\\r").replace(LS,"\\u2028").replace(PS,"\\u2029").replace(NL,"\\n").replace(LF,"\\f").replace(TB,"\\t");
}return s;
};
})(dust);
if(typeof exports!=="undefined"){if(typeof process!=="undefined"){require("./server")(dust);
}module.exports=dust;
}(function(e){e.compile=function(r,p){try{var o=h(e.parse(r));
return l(o,p);
}catch(q){if(!q.line||!q.column){throw q;
}throw new SyntaxError(q.message+" At line : "+q.line+", column : "+q.column);
}};
function h(o){var p={};
return e.filterNode(p,o);
}e.filterNode=function(o,p){return e.optimizers[p[0]](o,p);
};
e.optimizers={body:a,buffer:m,special:d,format:b,reference:i,"#":i,"?":i,"^":i,"<":i,"+":i,"@":i,"%":i,partial:i,context:i,params:i,bodies:i,param:i,filters:m,key:m,path:m,literal:m,comment:b};
e.pragmas={esc:function(s,r,p,t){var o=s.auto;
if(!r){r="h";
}s.auto=(r==="s")?"":r;
var q=j(s,p.block);
s.auto=o;
return q;
}};
function i(s,t){var p=[t[0]];
for(var r=1,o=t.length;
r<o;
r++){var q=e.filterNode(s,t[r]);
if(q){p.push(q);
}}return p;
}function a(t,u){var q=[u[0]],p;
for(var s=1,o=u.length;
s<o;
s++){var r=e.filterNode(t,u[s]);
if(r){if(r[0]==="buffer"){if(p){p[1]+=r[1];
}else{p=r;
q.push(r);
}}else{p=null;
q.push(r);
}}}return q;
}var c={"s":" ","n":"\n","r":"\r","lb":"{","rb":"}"};
function d(o,p){return["buffer",c[p[1]]];
}function m(o,p){return p;
}function b(){}function l(o,p){var q={name:p,bodies:[],blocks:{},index:0,auto:"h"};
return"(function(){dust.register("+(p?'"'+p+'"':"null")+","+e.compileNode(q,o)+");"+g(q)+f(q)+"return body_0;"+"})();";
}function g(q){var p=[],r=q.blocks;
for(var o in r){p.push("'"+o+"':"+r[o]);
}if(p.length){q.blocks="ctx=ctx.shiftBlocks(blocks);";
return"var blocks={"+p.join(",")+"};";
}return q.blocks="";
}function f(t){var r=[],q=t.bodies,p=t.blocks;
for(var s=0,o=q.length;
s<o;
s++){r[s]="function body_"+s+"(chk,ctx){"+p+"return chk"+q[s]+";}";
}return r.join("");
}function j(r,p){var s="";
for(var q=1,o=p.length;
q<o;
q++){s+=e.compileNode(r,p[q]);
}return s;
}e.compileNode=function(o,p){return e.nodes[p[0]](o,p);
};
e.nodes={body:function(p,q){var r=p.index++,o="body_"+r;
p.bodies[r]=j(p,q);
return o;
},buffer:function(o,p){return".write("+k(p[1])+")";
},format:function(o,p){return".write("+k(p[1]+p[2])+")";
},reference:function(o,p){return".reference("+e.compileNode(o,p[1])+",ctx,"+e.compileNode(o,p[2])+")";
},"#":function(o,p){return n(o,p,"section");
},"?":function(o,p){return n(o,p,"exists");
},"^":function(o,p){return n(o,p,"notexists");
},"<":function(r,t){var p=t[4];
for(var q=1,o=p.length;
q<o;
q++){var u=p[q],s=u[1][1];
if(s==="block"){r.blocks[t[1].text]=e.compileNode(r,u[2]);
return"";
}}return"";
},"+":function(o,p){if(typeof(p[1].text)==="undefined"&&typeof(p[4])==="undefined"){return".block(ctx.getBlock("+e.compileNode(o,p[1])+",chk, ctx),"+e.compileNode(o,p[2])+", {},"+e.compileNode(o,p[3])+")";
}else{return".block(ctx.getBlock("+k(p[1].text)+"),"+e.compileNode(o,p[2])+","+e.compileNode(o,p[4])+","+e.compileNode(o,p[3])+")";
}},"@":function(o,p){return".helper("+k(p[1].text)+","+e.compileNode(o,p[2])+","+e.compileNode(o,p[4])+","+e.compileNode(o,p[3])+")";
},"%":function(t,u){var r=u[1][1];
if(!e.pragmas[r]){return"";
}var x=u[4];
var o={};
for(var w=1,y=x.length;
w<y;
w++){var z=x[w];
o[z[1][1]]=z[2];
}var q=u[3];
var v={};
for(var w=1,y=q.length;
w<y;
w++){var s=q[w];
v[s[1][1]]=s[2][1];
}var A=u[2][1]?u[2][1].text:null;
return e.pragmas[r](t,A,o,v);
},partial:function(o,p){return".partial("+e.compileNode(o,p[1])+","+e.compileNode(o,p[2])+","+e.compileNode(o,p[3])+")";
},context:function(o,p){if(p[1]){return"ctx.rebase("+e.compileNode(o,p[1])+")";
}return"ctx";
},params:function(r,s){var p=[];
for(var q=1,o=s.length;
q<o;
q++){p.push(e.compileNode(r,s[q]));
}if(p.length){return"{"+p.join(",")+"}";
}return"null";
},bodies:function(r,s){var p=[];
for(var q=1,o=s.length;
q<o;
q++){p.push(e.compileNode(r,s[q]));
}return"{"+p.join(",")+"}";
},param:function(o,p){return e.compileNode(o,p[1])+":"+e.compileNode(o,p[2]);
},filters:function(q,s){var t=[];
for(var p=1,o=s.length;
p<o;
p++){var r=s[p];
t.push('"'+r+'"');
}return'"'+q.auto+'"'+(t.length?",["+t.join(",")+"]":"");
},key:function(o,p){return'ctx.get("'+p[1]+'")';
},path:function(q,s){var u=s[1],r=s[2],t=[];
for(var p=0,o=r.length;
p<o;
p++){t.push('"'+r[p]+'"');
}return"ctx.getPath("+u+",["+t.join(",")+"])";
},literal:function(o,p){return k(p[1]);
}};
function n(o,p,q){return"."+q+"("+e.compileNode(o,p[1])+","+e.compileNode(o,p[2])+","+e.compileNode(o,p[4])+","+e.compileNode(o,p[3])+")";
}var k=(typeof JSON==="undefined")?function(o){return'"'+e.escapeJs(o)+'"';
}:JSON.stringify;
})(typeof exports!=="undefined"?exports:getGlobal());
(function(a){var b=(function(){function d(e){return'"'+e.replace(/\\/g,"\\\\").replace(/"/g,'\\"').replace(/\x08/g,"\\b").replace(/\t/g,"\\t").replace(/\n/g,"\\n").replace(/\f/g,"\\f").replace(/\r/g,"\\r").replace(/[\x00-\x07\x0B\x0E-\x1F\x80-\uFFFF]/g,escape)+'"';
}var c={parse:function(i,n){var g={"body":z,"part":o,"section":t,"sec_tag_start":v,"end_tag":x,"context":V,"params":I,"bodies":A,"reference":Y,"partial":M,"filters":u,"special":f,"identifier":U,"number":E,"frac":W,"integer":H,"path":N,"key":L,"array":e,"array_part":p,"inline":R,"inline_part":O,"buffer":X,"literal":j,"esc":h,"comment":G,"tag":l,"ld":F,"rd":J,"eol":q,"ws":Q};
if(n!==undefined){if(g[n]===undefined){throw new Error("Invalid rule name: "+d(n)+".");
}}else{n="body";
}var K={offset:0,line:1,column:1,seenCR:false};
var T=0;
var k={offset:0,line:1,column:1,seenCR:false};
var s=[];
function Z(ab,af,ad){var aa=ab;
var ae=ad-ab.length;
for(var ac=0;
ac<ae;
ac++){aa=af+aa;
}return aa;
}function C(ac){var ab=ac.charCodeAt(0);
var aa;
var ad;
if(ab<=255){aa="x";
ad=2;
}else{aa="u";
ad=4;
}return"\\"+aa+Z(ab.toString(16).toUpperCase(),"0",ad);
}function B(ab){var aa={};
for(var ac in ab){aa[ac]=ab[ac];
}return aa;
}function r(ae,ad){var aa=ae.offset+ad;
for(var ac=ae.offset;
ac<aa;
ac++){var ab=i.charAt(ac);
if(ab==="\n"){if(!ae.seenCR){ae.line++;
}ae.column=1;
ae.seenCR=false;
}else{if(ab==="\r"||ab==="\u2028"||ab==="\u2029"){ae.line++;
ae.column=1;
ae.seenCR=true;
}else{ae.column++;
ae.seenCR=false;
}}}ae.offset+=ad;
}function w(aa){if(K.offset<k.offset){return;
}if(K.offset>k.offset){k=B(K);
s=[];
}s.push(aa);
}function z(){var ab,aa;
var ac;
ac=B(K);
ab=[];
aa=o();
while(aa!==null){ab.push(aa);
aa=o();
}if(ab!==null){ab=(function(ag,ad,ae,af){return["body"].concat(af);
})(ac.offset,ac.line,ac.column,ab);
}if(ab===null){K=B(ac);
}return ab;
}function o(){var aa;
aa=G();
if(aa===null){aa=t();
if(aa===null){aa=M();
if(aa===null){aa=f();
if(aa===null){aa=Y();
if(aa===null){aa=X();
}}}}}return aa;
}function t(){var ag,af,ae,ad,ac,ab,aa;
var ai,ah;
T++;
ai=B(K);
ah=B(K);
ag=v();
if(ag!==null){af=[];
ae=Q();
while(ae!==null){af.push(ae);
ae=Q();
}if(af!==null){ae=J();
if(ae!==null){ad=z();
if(ad!==null){ac=A();
if(ac!==null){ab=x();
if(ab!==null){aa=(function(ao,ak,am,al,aj,an,ap){return al[1].text===ap.text;
})(K.offset,K.line,K.column,ag,ad,ac,ab)?"":null;
if(aa!==null){ag=[ag,af,ae,ad,ac,ab,aa];
}else{ag=null;
K=B(ah);
}}else{ag=null;
K=B(ah);
}}else{ag=null;
K=B(ah);
}}else{ag=null;
K=B(ah);
}}else{ag=null;
K=B(ah);
}}else{ag=null;
K=B(ah);
}}else{ag=null;
K=B(ah);
}if(ag!==null){ag=(function(ao,ak,am,al,aj,an,ap){an.push(["param",["literal","block"],aj]);
al.push(an);
return al;
})(ai.offset,ai.line,ai.column,ag[0],ag[3],ag[4],ag[5]);
}if(ag===null){K=B(ai);
}if(ag===null){ai=B(K);
ah=B(K);
ag=v();
if(ag!==null){af=[];
ae=Q();
while(ae!==null){af.push(ae);
ae=Q();
}if(af!==null){if(i.charCodeAt(K.offset)===47){ae="/";
r(K,1);
}else{ae=null;
if(T===0){w('"/"');
}}if(ae!==null){ad=J();
if(ad!==null){ag=[ag,af,ae,ad];
}else{ag=null;
K=B(ah);
}}else{ag=null;
K=B(ah);
}}else{ag=null;
K=B(ah);
}}else{ag=null;
K=B(ah);
}if(ag!==null){ag=(function(am,aj,al,ak){ak.push(["bodies"]);
return ak;
})(ai.offset,ai.line,ai.column,ag[0]);
}if(ag===null){K=B(ai);
}}T--;
if(T===0&&ag===null){w("section");
}return ag;
}function v(){var ag,ae,ad,ac,ab,aa;
var ah,af;
ah=B(K);
af=B(K);
ag=F();
if(ag!==null){if(/^[#?^<+@%]/.test(i.charAt(K.offset))){ae=i.charAt(K.offset);
r(K,1);
}else{ae=null;
if(T===0){w("[#?^<+@%]");
}}if(ae!==null){ad=[];
ac=Q();
while(ac!==null){ad.push(ac);
ac=Q();
}if(ad!==null){ac=U();
if(ac!==null){ab=V();
if(ab!==null){aa=I();
if(aa!==null){ag=[ag,ae,ad,ac,ab,aa];
}else{ag=null;
K=B(af);
}}else{ag=null;
K=B(af);
}}else{ag=null;
K=B(af);
}}else{ag=null;
K=B(af);
}}else{ag=null;
K=B(af);
}}else{ag=null;
K=B(af);
}if(ag!==null){ag=(function(am,ai,ak,aj,ao,an,al){return[aj,ao,an,al];
})(ah.offset,ah.line,ah.column,ag[1],ag[3],ag[4],ag[5]);
}if(ag===null){K=B(ah);
}return ag;
}function x(){var ag,ae,ad,ac,ab,aa;
var ah,af;
T++;
ah=B(K);
af=B(K);
ag=F();
if(ag!==null){if(i.charCodeAt(K.offset)===47){ae="/";
r(K,1);
}else{ae=null;
if(T===0){w('"/"');
}}if(ae!==null){ad=[];
ac=Q();
while(ac!==null){ad.push(ac);
ac=Q();
}if(ad!==null){ac=U();
if(ac!==null){ab=[];
aa=Q();
while(aa!==null){ab.push(aa);
aa=Q();
}if(ab!==null){aa=J();
if(aa!==null){ag=[ag,ae,ad,ac,ab,aa];
}else{ag=null;
K=B(af);
}}else{ag=null;
K=B(af);
}}else{ag=null;
K=B(af);
}}else{ag=null;
K=B(af);
}}else{ag=null;
K=B(af);
}}else{ag=null;
K=B(af);
}if(ag!==null){ag=(function(ak,ai,aj,al){return al;
})(ah.offset,ah.line,ah.column,ag[3]);
}if(ag===null){K=B(ah);
}T--;
if(T===0&&ag===null){w("end tag");
}return ag;
}function V(){var ad,ab;
var ae,ac,aa;
ae=B(K);
ac=B(K);
aa=B(K);
if(i.charCodeAt(K.offset)===58){ad=":";
r(K,1);
}else{ad=null;
if(T===0){w('":"');
}}if(ad!==null){ab=U();
if(ab!==null){ad=[ad,ab];
}else{ad=null;
K=B(aa);
}}else{ad=null;
K=B(aa);
}if(ad!==null){ad=(function(ah,af,ag,ai){return ai;
})(ac.offset,ac.line,ac.column,ad[1]);
}if(ad===null){K=B(ac);
}ad=ad!==null?ad:"";
if(ad!==null){ad=(function(ah,af,ag,ai){return ai?["context",ai]:["context"];
})(ae.offset,ae.line,ae.column,ad);
}if(ad===null){K=B(ae);
}return ad;
}function I(){var ag,ae,ac,ab,aa;
var ah,af,ad;
T++;
ah=B(K);
ag=[];
af=B(K);
ad=B(K);
ac=Q();
if(ac!==null){ae=[];
while(ac!==null){ae.push(ac);
ac=Q();
}}else{ae=null;
}if(ae!==null){ac=L();
if(ac!==null){if(i.charCodeAt(K.offset)===61){ab="=";
r(K,1);
}else{ab=null;
if(T===0){w('"="');
}}if(ab!==null){aa=E();
if(aa===null){aa=U();
if(aa===null){aa=R();
}}if(aa!==null){ae=[ae,ac,ab,aa];
}else{ae=null;
K=B(ad);
}}else{ae=null;
K=B(ad);
}}else{ae=null;
K=B(ad);
}}else{ae=null;
K=B(ad);
}if(ae!==null){ae=(function(am,ai,al,ak,aj){return["param",["literal",ak],aj];
})(af.offset,af.line,af.column,ae[1],ae[3]);
}if(ae===null){K=B(af);
}while(ae!==null){ag.push(ae);
af=B(K);
ad=B(K);
ac=Q();
if(ac!==null){ae=[];
while(ac!==null){ae.push(ac);
ac=Q();
}}else{ae=null;
}if(ae!==null){ac=L();
if(ac!==null){if(i.charCodeAt(K.offset)===61){ab="=";
r(K,1);
}else{ab=null;
if(T===0){w('"="');
}}if(ab!==null){aa=E();
if(aa===null){aa=U();
if(aa===null){aa=R();
}}if(aa!==null){ae=[ae,ac,ab,aa];
}else{ae=null;
K=B(ad);
}}else{ae=null;
K=B(ad);
}}else{ae=null;
K=B(ad);
}}else{ae=null;
K=B(ad);
}if(ae!==null){ae=(function(am,ai,al,ak,aj){return["param",["literal",ak],aj];
})(af.offset,af.line,af.column,ae[1],ae[3]);
}if(ae===null){K=B(af);
}}if(ag!==null){ag=(function(al,ai,aj,ak){return["params"].concat(ak);
})(ah.offset,ah.line,ah.column,ag);
}if(ag===null){K=B(ah);
}T--;
if(T===0&&ag===null){w("params");
}return ag;
}function A(){var af,ae,ad,ac,ab,aa;
var ai,ah,ag;
T++;
ai=B(K);
af=[];
ah=B(K);
ag=B(K);
ae=F();
if(ae!==null){if(i.charCodeAt(K.offset)===58){ad=":";
r(K,1);
}else{ad=null;
if(T===0){w('":"');
}}if(ad!==null){ac=L();
if(ac!==null){ab=J();
if(ab!==null){aa=z();
if(aa!==null){ae=[ae,ad,ac,ab,aa];
}else{ae=null;
K=B(ag);
}}else{ae=null;
K=B(ag);
}}else{ae=null;
K=B(ag);
}}else{ae=null;
K=B(ag);
}}else{ae=null;
K=B(ag);
}if(ae!==null){ae=(function(an,aj,am,al,ak){return["param",["literal",al],ak];
})(ah.offset,ah.line,ah.column,ae[2],ae[4]);
}if(ae===null){K=B(ah);
}while(ae!==null){af.push(ae);
ah=B(K);
ag=B(K);
ae=F();
if(ae!==null){if(i.charCodeAt(K.offset)===58){ad=":";
r(K,1);
}else{ad=null;
if(T===0){w('":"');
}}if(ad!==null){ac=L();
if(ac!==null){ab=J();
if(ab!==null){aa=z();
if(aa!==null){ae=[ae,ad,ac,ab,aa];
}else{ae=null;
K=B(ag);
}}else{ae=null;
K=B(ag);
}}else{ae=null;
K=B(ag);
}}else{ae=null;
K=B(ag);
}}else{ae=null;
K=B(ag);
}if(ae!==null){ae=(function(an,aj,am,al,ak){return["param",["literal",al],ak];
})(ah.offset,ah.line,ah.column,ae[2],ae[4]);
}if(ae===null){K=B(ah);
}}if(af!==null){af=(function(am,aj,ak,al){return["bodies"].concat(al);
})(ai.offset,ai.line,ai.column,af);
}if(af===null){K=B(ai);
}T--;
if(T===0&&af===null){w("bodies");
}return af;
}function Y(){var ae,ac,ab,aa;
var af,ad;
T++;
af=B(K);
ad=B(K);
ae=F();
if(ae!==null){ac=U();
if(ac!==null){ab=u();
if(ab!==null){aa=J();
if(aa!==null){ae=[ae,ac,ab,aa];
}else{ae=null;
K=B(ad);
}}else{ae=null;
K=B(ad);
}}else{ae=null;
K=B(ad);
}}else{ae=null;
K=B(ad);
}if(ae!==null){ae=(function(aj,ag,ah,ak,ai){return["reference",ak,ai];
})(af.offset,af.line,af.column,ae[1],ae[2]);
}if(ae===null){K=B(af);
}T--;
if(T===0&&ae===null){w("reference");
}return ae;
}function M(){var ah,ag,af,ae,ad,ac,ab,aa;
var ak,aj,ai;
T++;
ak=B(K);
aj=B(K);
ah=F();
if(ah!==null){if(i.charCodeAt(K.offset)===62){ag=">";
r(K,1);
}else{ag=null;
if(T===0){w('">"');
}}if(ag===null){if(i.charCodeAt(K.offset)===43){ag="+";
r(K,1);
}else{ag=null;
if(T===0){w('"+"');
}}}if(ag!==null){ai=B(K);
af=L();
if(af!==null){af=(function(ao,al,an,am){return["literal",am];
})(ai.offset,ai.line,ai.column,af);
}if(af===null){K=B(ai);
}if(af===null){af=R();
}if(af!==null){ae=V();
if(ae!==null){ad=I();
if(ad!==null){ac=[];
ab=Q();
while(ab!==null){ac.push(ab);
ab=Q();
}if(ac!==null){if(i.charCodeAt(K.offset)===47){ab="/";
r(K,1);
}else{ab=null;
if(T===0){w('"/"');
}}if(ab!==null){aa=J();
if(aa!==null){ah=[ah,ag,af,ae,ad,ac,ab,aa];
}else{ah=null;
K=B(aj);
}}else{ah=null;
K=B(aj);
}}else{ah=null;
K=B(aj);
}}else{ah=null;
K=B(aj);
}}else{ah=null;
K=B(aj);
}}else{ah=null;
K=B(aj);
}}else{ah=null;
K=B(aj);
}}else{ah=null;
K=B(aj);
}if(ah!==null){ah=(function(aq,al,ao,an,at,ar,ap){var am=(an===">")?"partial":an;
return[am,at,ar,ap];
})(ak.offset,ak.line,ak.column,ah[1],ah[2],ah[3],ah[4]);
}if(ah===null){K=B(ak);
}T--;
if(T===0&&ah===null){w("partial");
}return ah;
}function u(){var ae,ac,aa;
var af,ad,ab;
T++;
af=B(K);
ae=[];
ad=B(K);
ab=B(K);
if(i.charCodeAt(K.offset)===124){ac="|";
r(K,1);
}else{ac=null;
if(T===0){w('"|"');
}}if(ac!==null){aa=L();
if(aa!==null){ac=[ac,aa];
}else{ac=null;
K=B(ab);
}}else{ac=null;
K=B(ab);
}if(ac!==null){ac=(function(ai,ag,ah,aj){return aj;
})(ad.offset,ad.line,ad.column,ac[1]);
}if(ac===null){K=B(ad);
}while(ac!==null){ae.push(ac);
ad=B(K);
ab=B(K);
if(i.charCodeAt(K.offset)===124){ac="|";
r(K,1);
}else{ac=null;
if(T===0){w('"|"');
}}if(ac!==null){aa=L();
if(aa!==null){ac=[ac,aa];
}else{ac=null;
K=B(ab);
}}else{ac=null;
K=B(ab);
}if(ac!==null){ac=(function(ai,ag,ah,aj){return aj;
})(ad.offset,ad.line,ad.column,ac[1]);
}if(ac===null){K=B(ad);
}}if(ae!==null){ae=(function(aj,ag,ah,ai){return["filters"].concat(ai);
})(af.offset,af.line,af.column,ae);
}if(ae===null){K=B(af);
}T--;
if(T===0&&ae===null){w("filters");
}return ae;
}function f(){var ae,ac,ab,aa;
var af,ad;
T++;
af=B(K);
ad=B(K);
ae=F();
if(ae!==null){if(i.charCodeAt(K.offset)===126){ac="~";
r(K,1);
}else{ac=null;
if(T===0){w('"~"');
}}if(ac!==null){ab=L();
if(ab!==null){aa=J();
if(aa!==null){ae=[ae,ac,ab,aa];
}else{ae=null;
K=B(ad);
}}else{ae=null;
K=B(ad);
}}else{ae=null;
K=B(ad);
}}else{ae=null;
K=B(ad);
}if(ae!==null){ae=(function(aj,ag,ai,ah){return["special",ah];
})(af.offset,af.line,af.column,ae[2]);
}if(ae===null){K=B(af);
}T--;
if(T===0&&ae===null){w("special");
}return ae;
}function U(){var aa;
var ab;
T++;
ab=B(K);
aa=N();
if(aa!==null){aa=(function(ag,ad,ae,af){var ac=["path"].concat(af);
ac.text=af[1].join(".");
return ac;
})(ab.offset,ab.line,ab.column,aa);
}if(aa===null){K=B(ab);
}if(aa===null){ab=B(K);
aa=L();
if(aa!==null){aa=(function(ag,ad,af,ae){var ac=["key",ae];
ac.text=ae;
return ac;
})(ab.offset,ab.line,ab.column,aa);
}if(aa===null){K=B(ab);
}}T--;
if(T===0&&aa===null){w("identifier");
}return aa;
}function E(){var aa;
var ab;
T++;
ab=B(K);
aa=W();
if(aa===null){aa=H();
}if(aa!==null){aa=(function(ae,ac,ad,af){return["literal",af];
})(ab.offset,ab.line,ab.column,aa);
}if(aa===null){K=B(ab);
}T--;
if(T===0&&aa===null){w("number");
}return aa;
}function W(){var ae,ac,ab,aa;
var af,ad;
T++;
af=B(K);
ad=B(K);
ae=H();
if(ae!==null){if(i.charCodeAt(K.offset)===46){ac=".";
r(K,1);
}else{ac=null;
if(T===0){w('"."');
}}if(ac!==null){aa=H();
if(aa!==null){ab=[];
while(aa!==null){ab.push(aa);
aa=H();
}}else{ab=null;
}if(ab!==null){ae=[ae,ac,ab];
}else{ae=null;
K=B(ad);
}}else{ae=null;
K=B(ad);
}}else{ae=null;
K=B(ad);
}if(ae!==null){ae=(function(ak,ah,ai,ag,aj){return parseFloat(ag+"."+aj.join(""));
})(af.offset,af.line,af.column,ae[0],ae[2]);
}if(ae===null){K=B(af);
}T--;
if(T===0&&ae===null){w("frac");
}return ae;
}function H(){var ab,aa;
var ac;
T++;
ac=B(K);
if(/^[0-9]/.test(i.charAt(K.offset))){aa=i.charAt(K.offset);
r(K,1);
}else{aa=null;
if(T===0){w("[0-9]");
}}if(aa!==null){ab=[];
while(aa!==null){ab.push(aa);
if(/^[0-9]/.test(i.charAt(K.offset))){aa=i.charAt(K.offset);
r(K,1);
}else{aa=null;
if(T===0){w("[0-9]");
}}}}else{ab=null;
}if(ab!==null){ab=(function(ag,ad,ae,af){return parseInt(af.join(""),10);
})(ac.offset,ac.line,ac.column,ab);
}if(ab===null){K=B(ac);
}T--;
if(T===0&&ab===null){w("integer");
}return ab;
}function N(){var ad,ab,aa;
var ae,ac;
T++;
ae=B(K);
ac=B(K);
ad=L();
ad=ad!==null?ad:"";
if(ad!==null){aa=p();
if(aa===null){aa=e();
}if(aa!==null){ab=[];
while(aa!==null){ab.push(aa);
aa=p();
if(aa===null){aa=e();
}}}else{ab=null;
}if(ab!==null){ad=[ad,ab];
}else{ad=null;
K=B(ac);
}}else{ad=null;
K=B(ac);
}if(ad!==null){ad=(function(aj,af,ah,ag,ai){ai=ai[0];
if(ag&&ai){ai.unshift(ag);
return[false,ai];
}return[true,ai];
})(ae.offset,ae.line,ae.column,ad[0],ad[1]);
}if(ad===null){K=B(ae);
}if(ad===null){ae=B(K);
ac=B(K);
if(i.charCodeAt(K.offset)===46){ad=".";
r(K,1);
}else{ad=null;
if(T===0){w('"."');
}}if(ad!==null){ab=[];
aa=p();
if(aa===null){aa=e();
}while(aa!==null){ab.push(aa);
aa=p();
if(aa===null){aa=e();
}}if(ab!==null){ad=[ad,ab];
}else{ad=null;
K=B(ac);
}}else{ad=null;
K=B(ac);
}if(ad!==null){ad=(function(ai,af,ag,ah){if(ah.length>0){return[true,ah[0]];
}return[true,[]];
})(ae.offset,ae.line,ae.column,ad[1]);
}if(ad===null){K=B(ae);
}}T--;
if(T===0&&ad===null){w("path");
}return ad;
}function L(){var ad,ab,aa;
var ae,ac;
T++;
ae=B(K);
ac=B(K);
if(/^[a-zA-Z_$]/.test(i.charAt(K.offset))){ad=i.charAt(K.offset);
r(K,1);
}else{ad=null;
if(T===0){w("[a-zA-Z_$]");
}}if(ad!==null){ab=[];
if(/^[0-9a-zA-Z_$\-]/.test(i.charAt(K.offset))){aa=i.charAt(K.offset);
r(K,1);
}else{aa=null;
if(T===0){w("[0-9a-zA-Z_$\\-]");
}}while(aa!==null){ab.push(aa);
if(/^[0-9a-zA-Z_$\-]/.test(i.charAt(K.offset))){aa=i.charAt(K.offset);
r(K,1);
}else{aa=null;
if(T===0){w("[0-9a-zA-Z_$\\-]");
}}}if(ab!==null){ad=[ad,ab];
}else{ad=null;
K=B(ac);
}}else{ad=null;
K=B(ac);
}if(ad!==null){ad=(function(aj,af,ai,ah,ag){return ah+ag.join("");
})(ae.offset,ae.line,ae.column,ad[0],ad[1]);
}if(ad===null){K=B(ae);
}T--;
if(T===0&&ad===null){w("key");
}return ad;
}function e(){var af,ad,ab;
var ag,ae,ac,aa;
T++;
ag=B(K);
ae=B(K);
ac=B(K);
aa=B(K);
if(i.charCodeAt(K.offset)===91){af="[";
r(K,1);
}else{af=null;
if(T===0){w('"["');
}}if(af!==null){if(/^[0-9]/.test(i.charAt(K.offset))){ab=i.charAt(K.offset);
r(K,1);
}else{ab=null;
if(T===0){w("[0-9]");
}}if(ab!==null){ad=[];
while(ab!==null){ad.push(ab);
if(/^[0-9]/.test(i.charAt(K.offset))){ab=i.charAt(K.offset);
r(K,1);
}else{ab=null;
if(T===0){w("[0-9]");
}}}}else{ad=null;
}if(ad!==null){if(i.charCodeAt(K.offset)===93){ab="]";
r(K,1);
}else{ab=null;
if(T===0){w('"]"');
}}if(ab!==null){af=[af,ad,ab];
}else{af=null;
K=B(aa);
}}else{af=null;
K=B(aa);
}}else{af=null;
K=B(aa);
}if(af!==null){af=(function(ak,ai,aj,ah){return ah.join("");
})(ac.offset,ac.line,ac.column,af[1]);
}if(af===null){K=B(ac);
}if(af!==null){ad=p();
ad=ad!==null?ad:"";
if(ad!==null){af=[af,ad];
}else{af=null;
K=B(ae);
}}else{af=null;
K=B(ae);
}if(af!==null){af=(function(al,ah,ak,aj,ai){if(ai){ai.unshift(aj);
}else{ai=[aj];
}return ai;
})(ag.offset,ag.line,ag.column,af[0],af[1]);
}if(af===null){K=B(ag);
}T--;
if(T===0&&af===null){w("array");
}return af;
}function p(){var af,ad,ab;
var ag,ae,ac,aa;
T++;
ag=B(K);
ae=B(K);
ac=B(K);
aa=B(K);
if(i.charCodeAt(K.offset)===46){ad=".";
r(K,1);
}else{ad=null;
if(T===0){w('"."');
}}if(ad!==null){ab=L();
if(ab!==null){ad=[ad,ab];
}else{ad=null;
K=B(aa);
}}else{ad=null;
K=B(aa);
}if(ad!==null){ad=(function(ak,ah,aj,ai){return ai;
})(ac.offset,ac.line,ac.column,ad[1]);
}if(ad===null){K=B(ac);
}if(ad!==null){af=[];
while(ad!==null){af.push(ad);
ac=B(K);
aa=B(K);
if(i.charCodeAt(K.offset)===46){ad=".";
r(K,1);
}else{ad=null;
if(T===0){w('"."');
}}if(ad!==null){ab=L();
if(ab!==null){ad=[ad,ab];
}else{ad=null;
K=B(aa);
}}else{ad=null;
K=B(aa);
}if(ad!==null){ad=(function(ak,ah,aj,ai){return ai;
})(ac.offset,ac.line,ac.column,ad[1]);
}if(ad===null){K=B(ac);
}}}else{af=null;
}if(af!==null){ad=e();
ad=ad!==null?ad:"";
if(ad!==null){af=[af,ad];
}else{af=null;
K=B(ae);
}}else{af=null;
K=B(ae);
}if(af!==null){af=(function(al,ai,aj,ak,ah){if(ah){return ak.concat(ah);
}else{return ak;
}})(ag.offset,ag.line,ag.column,af[0],af[1]);
}if(af===null){K=B(ag);
}T--;
if(T===0&&af===null){w("array_part");
}return af;
}function R(){var ad,ab,aa;
var ae,ac;
T++;
ae=B(K);
ac=B(K);
if(i.charCodeAt(K.offset)===34){ad='"';
r(K,1);
}else{ad=null;
if(T===0){w('"\\""');
}}if(ad!==null){if(i.charCodeAt(K.offset)===34){ab='"';
r(K,1);
}else{ab=null;
if(T===0){w('"\\""');
}}if(ab!==null){ad=[ad,ab];
}else{ad=null;
K=B(ac);
}}else{ad=null;
K=B(ac);
}if(ad!==null){ad=(function(ah,af,ag){return["literal",""];
})(ae.offset,ae.line,ae.column);
}if(ad===null){K=B(ae);
}if(ad===null){ae=B(K);
ac=B(K);
if(i.charCodeAt(K.offset)===34){ad='"';
r(K,1);
}else{ad=null;
if(T===0){w('"\\""');
}}if(ad!==null){ab=j();
if(ab!==null){if(i.charCodeAt(K.offset)===34){aa='"';
r(K,1);
}else{aa=null;
if(T===0){w('"\\""');
}}if(aa!==null){ad=[ad,ab,aa];
}else{ad=null;
K=B(ac);
}}else{ad=null;
K=B(ac);
}}else{ad=null;
K=B(ac);
}if(ad!==null){ad=(function(ai,ag,ah,af){return["literal",af];
})(ae.offset,ae.line,ae.column,ad[1]);
}if(ad===null){K=B(ae);
}if(ad===null){ae=B(K);
ac=B(K);
if(i.charCodeAt(K.offset)===34){ad='"';
r(K,1);
}else{ad=null;
if(T===0){w('"\\""');
}}if(ad!==null){aa=O();
if(aa!==null){ab=[];
while(aa!==null){ab.push(aa);
aa=O();
}}else{ab=null;
}if(ab!==null){if(i.charCodeAt(K.offset)===34){aa='"';
r(K,1);
}else{aa=null;
if(T===0){w('"\\""');
}}if(aa!==null){ad=[ad,ab,aa];
}else{ad=null;
K=B(ac);
}}else{ad=null;
K=B(ac);
}}else{ad=null;
K=B(ac);
}if(ad!==null){ad=(function(ai,af,ag,ah){return["body"].concat(ah);
})(ae.offset,ae.line,ae.column,ad[1]);
}if(ad===null){K=B(ae);
}}}T--;
if(T===0&&ad===null){w("inline");
}return ad;
}function O(){var aa;
var ab;
aa=f();
if(aa===null){aa=Y();
if(aa===null){ab=B(K);
aa=j();
if(aa!==null){aa=(function(af,ad,ae,ac){return["buffer",ac];
})(ab.offset,ab.line,ab.column,aa);
}if(aa===null){K=B(ab);
}}}return aa;
}function X(){var ae,ad,ac,ab,aa;
var ai,ah,ag,af;
T++;
ai=B(K);
ah=B(K);
ae=q();
if(ae!==null){ad=[];
ac=Q();
while(ac!==null){ad.push(ac);
ac=Q();
}if(ad!==null){ae=[ae,ad];
}else{ae=null;
K=B(ah);
}}else{ae=null;
K=B(ah);
}if(ae!==null){ae=(function(an,ak,al,am,aj){return["format",am,aj.join("")];
})(ai.offset,ai.line,ai.column,ae[0],ae[1]);
}if(ae===null){K=B(ai);
}if(ae===null){ai=B(K);
ah=B(K);
ag=B(K);
af=B(K);
T++;
ad=l();
T--;
if(ad===null){ad="";
}else{ad=null;
K=B(af);
}if(ad!==null){af=B(K);
T++;
ac=q();
T--;
if(ac===null){ac="";
}else{ac=null;
K=B(af);
}if(ac!==null){af=B(K);
T++;
ab=G();
T--;
if(ab===null){ab="";
}else{ab=null;
K=B(af);
}if(ab!==null){if(i.length>K.offset){aa=i.charAt(K.offset);
r(K,1);
}else{aa=null;
if(T===0){w("any character");
}}if(aa!==null){ad=[ad,ac,ab,aa];
}else{ad=null;
K=B(ag);
}}else{ad=null;
K=B(ag);
}}else{ad=null;
K=B(ag);
}}else{ad=null;
K=B(ag);
}if(ad!==null){ad=(function(al,aj,ak,am){return am;
})(ah.offset,ah.line,ah.column,ad[3]);
}if(ad===null){K=B(ah);
}if(ad!==null){ae=[];
while(ad!==null){ae.push(ad);
ah=B(K);
ag=B(K);
af=B(K);
T++;
ad=l();
T--;
if(ad===null){ad="";
}else{ad=null;
K=B(af);
}if(ad!==null){af=B(K);
T++;
ac=q();
T--;
if(ac===null){ac="";
}else{ac=null;
K=B(af);
}if(ac!==null){af=B(K);
T++;
ab=G();
T--;
if(ab===null){ab="";
}else{ab=null;
K=B(af);
}if(ab!==null){if(i.length>K.offset){aa=i.charAt(K.offset);
r(K,1);
}else{aa=null;
if(T===0){w("any character");
}}if(aa!==null){ad=[ad,ac,ab,aa];
}else{ad=null;
K=B(ag);
}}else{ad=null;
K=B(ag);
}}else{ad=null;
K=B(ag);
}}else{ad=null;
K=B(ag);
}if(ad!==null){ad=(function(al,aj,ak,am){return am;
})(ah.offset,ah.line,ah.column,ad[3]);
}if(ad===null){K=B(ah);
}}}else{ae=null;
}if(ae!==null){ae=(function(am,ak,al,aj){return["buffer",aj.join("")];
})(ai.offset,ai.line,ai.column,ae);
}if(ae===null){K=B(ai);
}}T--;
if(T===0&&ae===null){w("buffer");
}return ae;
}function j(){var af,ad,ab;
var ag,ae,ac,aa;
T++;
ag=B(K);
ae=B(K);
ac=B(K);
aa=B(K);
T++;
ad=l();
T--;
if(ad===null){ad="";
}else{ad=null;
K=B(aa);
}if(ad!==null){ab=h();
if(ab===null){if(/^[^"]/.test(i.charAt(K.offset))){ab=i.charAt(K.offset);
r(K,1);
}else{ab=null;
if(T===0){w('[^"]');
}}}if(ab!==null){ad=[ad,ab];
}else{ad=null;
K=B(ac);
}}else{ad=null;
K=B(ac);
}if(ad!==null){ad=(function(aj,ah,ai,ak){return ak;
})(ae.offset,ae.line,ae.column,ad[1]);
}if(ad===null){K=B(ae);
}if(ad!==null){af=[];
while(ad!==null){af.push(ad);
ae=B(K);
ac=B(K);
aa=B(K);
T++;
ad=l();
T--;
if(ad===null){ad="";
}else{ad=null;
K=B(aa);
}if(ad!==null){ab=h();
if(ab===null){if(/^[^"]/.test(i.charAt(K.offset))){ab=i.charAt(K.offset);
r(K,1);
}else{ab=null;
if(T===0){w('[^"]');
}}}if(ab!==null){ad=[ad,ab];
}else{ad=null;
K=B(ac);
}}else{ad=null;
K=B(ac);
}if(ad!==null){ad=(function(aj,ah,ai,ak){return ak;
})(ae.offset,ae.line,ae.column,ad[1]);
}if(ad===null){K=B(ae);
}}}else{af=null;
}if(af!==null){af=(function(ak,ai,aj,ah){return ah.join("");
})(ag.offset,ag.line,ag.column,af);
}if(af===null){K=B(ag);
}T--;
if(T===0&&af===null){w("literal");
}return af;
}function h(){var aa;
var ab;
ab=B(K);
if(i.substr(K.offset,2)==='\\"'){aa='\\"';
r(K,2);
}else{aa=null;
if(T===0){w('"\\\\\\""');
}}if(aa!==null){aa=(function(ae,ac,ad){return'"';
})(ab.offset,ab.line,ab.column);
}if(aa===null){K=B(ab);
}return aa;
}function G(){var ad,ac,ab,aa;
var ai,ah,ag,af,ae;
T++;
ai=B(K);
ah=B(K);
if(i.substr(K.offset,2)==="{!"){ad="{!";
r(K,2);
}else{ad=null;
if(T===0){w('"{!"');
}}if(ad!==null){ac=[];
ag=B(K);
af=B(K);
ae=B(K);
T++;
if(i.substr(K.offset,2)==="!}"){ab="!}";
r(K,2);
}else{ab=null;
if(T===0){w('"!}"');
}}T--;
if(ab===null){ab="";
}else{ab=null;
K=B(ae);
}if(ab!==null){if(i.length>K.offset){aa=i.charAt(K.offset);
r(K,1);
}else{aa=null;
if(T===0){w("any character");
}}if(aa!==null){ab=[ab,aa];
}else{ab=null;
K=B(af);
}}else{ab=null;
K=B(af);
}if(ab!==null){ab=(function(al,aj,ak,am){return am;
})(ag.offset,ag.line,ag.column,ab[1]);
}if(ab===null){K=B(ag);
}while(ab!==null){ac.push(ab);
ag=B(K);
af=B(K);
ae=B(K);
T++;
if(i.substr(K.offset,2)==="!}"){ab="!}";
r(K,2);
}else{ab=null;
if(T===0){w('"!}"');
}}T--;
if(ab===null){ab="";
}else{ab=null;
K=B(ae);
}if(ab!==null){if(i.length>K.offset){aa=i.charAt(K.offset);
r(K,1);
}else{aa=null;
if(T===0){w("any character");
}}if(aa!==null){ab=[ab,aa];
}else{ab=null;
K=B(af);
}}else{ab=null;
K=B(af);
}if(ab!==null){ab=(function(al,aj,ak,am){return am;
})(ag.offset,ag.line,ag.column,ab[1]);
}if(ab===null){K=B(ag);
}}if(ac!==null){if(i.substr(K.offset,2)==="!}"){ab="!}";
r(K,2);
}else{ab=null;
if(T===0){w('"!}"');
}}if(ab!==null){ad=[ad,ac,ab];
}else{ad=null;
K=B(ah);
}}else{ad=null;
K=B(ah);
}}else{ad=null;
K=B(ah);
}if(ad!==null){ad=(function(al,aj,ak,am){return["comment",am.join("")];
})(ai.offset,ai.line,ai.column,ad[1]);
}if(ad===null){K=B(ai);
}T--;
if(T===0&&ad===null){w("comment");
}return ad;
}function l(){var ag,af,ae,ad,ac,ab,aa;
var aj,ai,ah;
aj=B(K);
ag=F();
if(ag!==null){if(/^[#?^><+%:@\/~%]/.test(i.charAt(K.offset))){af=i.charAt(K.offset);
r(K,1);
}else{af=null;
if(T===0){w("[#?^><+%:@\\/~%]");
}}if(af!==null){ae=[];
ad=Q();
while(ad!==null){ae.push(ad);
ad=Q();
}if(ae!==null){ai=B(K);
ah=B(K);
T++;
ac=J();
T--;
if(ac===null){ac="";
}else{ac=null;
K=B(ah);
}if(ac!==null){ah=B(K);
T++;
ab=q();
T--;
if(ab===null){ab="";
}else{ab=null;
K=B(ah);
}if(ab!==null){if(i.length>K.offset){aa=i.charAt(K.offset);
r(K,1);
}else{aa=null;
if(T===0){w("any character");
}}if(aa!==null){ac=[ac,ab,aa];
}else{ac=null;
K=B(ai);
}}else{ac=null;
K=B(ai);
}}else{ac=null;
K=B(ai);
}if(ac!==null){ad=[];
while(ac!==null){ad.push(ac);
ai=B(K);
ah=B(K);
T++;
ac=J();
T--;
if(ac===null){ac="";
}else{ac=null;
K=B(ah);
}if(ac!==null){ah=B(K);
T++;
ab=q();
T--;
if(ab===null){ab="";
}else{ab=null;
K=B(ah);
}if(ab!==null){if(i.length>K.offset){aa=i.charAt(K.offset);
r(K,1);
}else{aa=null;
if(T===0){w("any character");
}}if(aa!==null){ac=[ac,ab,aa];
}else{ac=null;
K=B(ai);
}}else{ac=null;
K=B(ai);
}}else{ac=null;
K=B(ai);
}}}else{ad=null;
}if(ad!==null){ac=[];
ab=Q();
while(ab!==null){ac.push(ab);
ab=Q();
}if(ac!==null){ab=J();
if(ab!==null){ag=[ag,af,ae,ad,ac,ab];
}else{ag=null;
K=B(aj);
}}else{ag=null;
K=B(aj);
}}else{ag=null;
K=B(aj);
}}else{ag=null;
K=B(aj);
}}else{ag=null;
K=B(aj);
}}else{ag=null;
K=B(aj);
}if(ag===null){ag=Y();
}return ag;
}function F(){var aa;
if(i.charCodeAt(K.offset)===123){aa="{";
r(K,1);
}else{aa=null;
if(T===0){w('"{"');
}}return aa;
}function J(){var aa;
if(i.charCodeAt(K.offset)===125){aa="}";
r(K,1);
}else{aa=null;
if(T===0){w('"}"');
}}return aa;
}function q(){var aa;
if(i.charCodeAt(K.offset)===10){aa="\n";
r(K,1);
}else{aa=null;
if(T===0){w('"\\n"');
}}if(aa===null){if(i.substr(K.offset,2)==="\r\n"){aa="\r\n";
r(K,2);
}else{aa=null;
if(T===0){w('"\\r\\n"');
}}if(aa===null){if(i.charCodeAt(K.offset)===13){aa="\r";
r(K,1);
}else{aa=null;
if(T===0){w('"\\r"');
}}if(aa===null){if(i.charCodeAt(K.offset)===8232){aa="\u2028";
r(K,1);
}else{aa=null;
if(T===0){w('"\\u2028"');
}}if(aa===null){if(i.charCodeAt(K.offset)===8233){aa="\u2029";
r(K,1);
}else{aa=null;
if(T===0){w('"\\u2029"');
}}}}}}return aa;
}function Q(){var aa;
if(/^[\t\x0B\f \xA0\uFEFF]/.test(i.charAt(K.offset))){aa=i.charAt(K.offset);
r(K,1);
}else{aa=null;
if(T===0){w("[\\t\\x0B\\f \\xA0\\uFEFF]");
}}if(aa===null){aa=q();
}return aa;
}function D(ac){ac.sort();
var ad=null;
var ab=[];
for(var aa=0;
aa<ac.length;
aa++){if(ac[aa]!==ad){ab.push(ac[aa]);
ad=ac[aa];
}}return ab;
}var y=g[n]();
if(y===null||K.offset!==i.length){var P=Math.max(K.offset,k.offset);
var m=P<i.length?i.charAt(P):null;
var S=K.offset>k.offset?K:k;
throw new b.SyntaxError(D(s),m,P,S.line,S.column);
}return y;
},toSource:function(){return this._source;
}};
c.SyntaxError=function(h,i,j,f,g){function e(m,n){var k,l;
switch(m.length){case 0:k="end of input";
break;
case 1:k=m[0];
break;
default:k=m.slice(0,m.length-1).join(", ")+" or "+m[m.length-1];
}l=n?d(n):"end of input";
return"Expected "+k+" but "+l+" found.";
}this.name="SyntaxError";
this.expected=h;
this.found=i;
this.message=e(h,i);
this.offset=j;
this.line=f;
this.column=g;
};
c.SyntaxError.prototype=Error.prototype;
return c;
})();
a.parse=b.parse;
})(typeof exports!=="undefined"?exports:getGlobal());
